// eslint-ignore-rule no-console
import { attach } from '../src/index';

import * as cp from 'child_process';

import { inspect } from 'util';

const proc = cp.spawn(
  'nvim',
  ['-u', 'NONE', '-N', '--embed', '-c', 'set noswapfile', 'test2js'],
  {
    cwd: __dirname,
  }
);

// const net = require('net');

async function main() {
  const nvim = await attach({ proc });
  // const nvim = await attach({ socket: '/tmp/nvim2' });
  nvim.on('request', (method, args, resp) => {
    // handle msgpack-rpc request
    console.log('request', method, args, resp);
  });

  nvim.on('notification', (method, args) => {
    // handle msgpack-rpc notification
    console.log('notification', method, args);
  });

  const win = await nvim.window;
  nvim.command('vsplit');
  console.log(await nvim.window.row);
  console.log(await nvim.window.col);
  // await nvim.command('edit test.js');
  // await nvim.command('vsp');
  // const windows = await nvim.listWins();

  // console.log(windows.length);

  // nvim.setCurrentWin(windows[1]);
  // const win = await nvim.getCurrentWin();
  // console.log(win._data, windows[1]._data);

  // const buf = await nvim.getCurrentBuf();
  // console.log(buf instanceof nvim.Buffer);

  // const lines = await buf.getLines(0, -1, true);
  // console.log(lines);

  // await buf.setLines(0, -1, true, ['line1', 'line2']);
  // const newLines = await buf.getLines(0, -1, true);
  // console.log(newLines);
}

try {
  main();
} catch (err) {
  console.error(err);
  process.exit(1);
}
process.on('unhandledRejection', (reason, p) => {
  console.log('Unhandled Rejection at:', p, 'reason:', reason);
  process.exit(1);
  // application specific logging, throwing an error, or other logic here
});
